local AceGUI = LibStub("AceGUI-3.0")
local refPoints = {"CENTER", "TOPLEFT", "LEFT", "BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT", "RIGHT", "TOPRIGHT", "TOP"}
local sativ = {
	UnitFrames = {
		player = {
			x = -350,
			y = 125,
			ref = "CENTER",
			scale = 1
		},
		target = {
			x = -250,
			y = 75,
			ref = "CENTER",
			scale = 1
		},
		focus = {
			x = -500,
			y = 125,
			ref = "CENTER",
			scale = 1
		},
		arena = {
			x = 150,
			y = 250,
			ref = "BOTTOMLEFT",
			scale = 1.4
		},
		party = {
			x = 75,
			y = 75,
			ref = "LEFT",
			scale = 1.2
		},
		classIcons = true
	},
	ActionBars = {
		modify = true,
		macroText = true,
		CastBar = {
			x = 0,
			y = 250,
		}
	}
}
local reloadNeeded = false
local function PositionPartyFrames()
	local DB = PUI.db.profile.UnitFrames.party
	for i=1,4 do _G["PartyMemberFrame"..i]:ClearAllPoints() end
	PartyMemberFrame1:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y)
	PartyMemberFrame2:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-50)
	PartyMemberFrame3:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-100)
	PartyMemberFrame4:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-150)
	for i=1,4 do _G["PartyMemberFrame"..i]:Show() _G["PartyMemberFrame"..i]:SetScale(DB.scale) end
end
local function PositionArenaFrames()
	if not IsAddOnLoaded("Blizzard_ArenaUI") then
		LoadAddOn("Blizzard_ArenaUI")
	end
	ArenaEnemyFrames:Show()
	for i=1,5 do _G["ArenaEnemyFrame"..i]:Show()_G["ArenaEnemyFrame"..i.."CastingBar"]:Show()end
	PUI:testAEF()
	local DB = PUI.db.profile.UnitFrames.arena
	for i=1,5 do _G["ArenaPrepFrame"..i]:ClearAllPoints() end
	for i=1,5 do _G["ArenaEnemyFrame"..i]:ClearAllPoints() end
			
	ArenaPrepFrame1:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y)
	ArenaPrepFrame2:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-50)
	ArenaPrepFrame3:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-100)
	ArenaPrepFrame4:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-150)
	ArenaPrepFrame5:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-200)
	ArenaEnemyFrame1:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y)
	ArenaEnemyFrame2:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-50)
	ArenaEnemyFrame3:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-100)
	ArenaEnemyFrame4:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-150)
	ArenaEnemyFrame5:SetPoint(DB.ref,UIParent,DB.ref,DB.x,DB.y-200)
	
	ArenaEnemyFrames:SetScale(DB.scale)
	for i=1,5 do _G["ArenaPrepFrame"..i]:SetScale(DB.scale) end
	
	DRTracker:TestDRs()
end
		-- PLAYER ------------------------------------------
local function playerDropdown(widget, event, key)
	local DB = PUI.db.profile.UnitFrames.player
	DB.ref = refPoints[key]
	PlayerFrame:ClearAllPoints()
	PlayerFrame:SetPoint(DB.ref, UIParent, DB.ref, DB.x, DB.y)
end
local function playerXChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.player
	DB.x = text
	PlayerFrame:ClearAllPoints()
	PlayerFrame:SetPoint(DB.ref, UIParent, DB.ref, DB.x, DB.y)
end
local function playerYChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.player
	DB.y = text
	PlayerFrame:ClearAllPoints()
	PlayerFrame:SetPoint(DB.ref, UIParent, DB.ref, DB.x, DB.y)
end
local function playerSclChange(widget, event, newScale)
	local DB = PUI.db.profile.UnitFrames.player
	DB.scale = newScale
	PlayerFrame:SetScale(DB.scale)
end
		-- TARGET -------------------------------------------
local function targetDropdown(widget, event, key)
	local DB = PUI.db.profile.UnitFrames.target
	DB.ref = refPoints[key]
	TargetFrame:ClearAllPoints()
	TargetFrame:SetPoint(DB.ref, UIParent, DB.ref, DB.x, DB.y)
end
local function targetXChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.target
	DB.x = text
	TargetFrame:ClearAllPoints()
	TargetFrame:SetPoint(DB.ref, UIParent, DB.ref, DB.x, DB.y)
end
local function targetYChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.target
	DB.y = text
	TargetFrame:ClearAllPoints()
	TargetFrame:SetPoint(DB.ref, UIParent, DB.ref, DB.x, DB.y)
end
local function targetSclChange(widget, event, newScale)
	local DB = PUI.db.profile.UnitFrames.target
	DB.scale = newScale
	TargetFrame:SetScale(DB.scale)
end
		-- FOCUS -------------------------------------------
local function focusDropdown(widget, event, key)
	local DB = PUI.db.profile.UnitFrames.focus
	DB.ref = refPoints[key]
	FocusFrame:ClearAllPoints()
	FocusFrame:SetPoint(DB.ref, UIParent, DB.ref, DB.x, DB.y)
end
local function focusXChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.focus
	DB.x = text
	FocusFrame:ClearAllPoints()
	FocusFrame:SetPoint(DB.ref, UIParent, DB.ref, DB.x, DB.y)
end
local function focusYChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.focus
	DB.y = text
	FocusFrame:ClearAllPoints()
	FocusFrame:SetPoint(DB.ref, UIParent, DB.ref, DB.x, DB.y)
end
local function focusSclChange(widget, event, newScale)
	local DB = PUI.db.profile.UnitFrames.focus
	DB.scale = newScale
	FocusFrame:SetScale(DB.scale)
end
		-- ARENA -------------------------------------------
local function arenaDropdown(widget, event, key)
	local DB = PUI.db.profile.UnitFrames.arena
	DB.ref = refPoints[key]
	PositionArenaFrames()
	reloadNeeded = true
end
local function arenaXChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.arena
	DB.x = text
	PositionArenaFrames()
	reloadNeeded = true
end
local function arenaYChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.arena
	DB.y = text
	PositionArenaFrames()
	reloadNeeded = true
end
local function arenaSclChange(widget, event, newScale)
	local DB = PUI.db.profile.UnitFrames.arena
	DB.scale = newScale
	PositionArenaFrames()
	reloadNeeded = true
end
		-- PARTY -------------------------------------------
local function partyDropdown(widget, event, key)
	local DB = PUI.db.profile.UnitFrames.party
	DB.ref = refPoints[key]
	PositionPartyFrames()
	reloadNeeded = true
end
local function partyXChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.party
	DB.x = text
	PositionPartyFrames()
	reloadNeeded = true
end
local function partyYChange(widget, event, text)
	local DB = PUI.db.profile.UnitFrames.party
	DB.y = text
	PositionPartyFrames()
	reloadNeeded = true
end
local function partySclChange(widget, event, newScale)
	local DB = PUI.db.profile.UnitFrames.party
	DB.scale = newScale
	PositionPartyFrames()
	reloadNeeded = true
end

function PUI:OpenConfig(curProfile)
	PositionPartyFrames()
	PositionArenaFrames()
	reloadNeeded = true
	local frame = AceGUI:Create("Frame")
	frame:SetTitle("PowerUI Settings")
	frame:SetStatusText(curProfile)
	frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) if reloadNeeded then ReloadUI() end end)
	frame:SetLayout("Flow")
	
			-- SATIV BUTTON
	local sativPic = AceGUI:Create("Icon")
	sativPic:SetImage("Interface\\AddOns\\PowerInterface\\Media\\sativ.tga")
	sativPic:SetImageSize(60, 60)
	frame:AddChild(sativPic)
	local sativButtonLabel = AceGUI:Create("Label")
	sativButtonLabel:SetText("Do you watch Sativ's stream or youtube videos? Want his layout?         ")
	sativButtonLabel:SetWidth(340)
	frame:AddChild(sativButtonLabel)
	local sativButton = AceGUI:Create("Button")
	sativButton:SetText("Use Sativ Layout")
	sativButton:SetWidth(150)
	sativButton:SetCallback("OnClick", function(widget)
		local DB = self.db.profile
		DB.UnitFrames.player.x = sativ.UnitFrames.player.x
		DB.UnitFrames.player.y = sativ.UnitFrames.player.y
		DB.UnitFrames.player.ref = sativ.UnitFrames.player.ref
		DB.UnitFrames.player.scale = sativ.UnitFrames.player.scale
		
		DB.UnitFrames.target.x = sativ.UnitFrames.target.x
		DB.UnitFrames.target.y = sativ.UnitFrames.target.y
		DB.UnitFrames.target.ref = sativ.UnitFrames.target.ref
		DB.UnitFrames.target.scale = sativ.UnitFrames.target.scale
		
		DB.UnitFrames.focus.x = sativ.UnitFrames.focus.x
		DB.UnitFrames.focus.y = sativ.UnitFrames.focus.y
		DB.UnitFrames.focus.ref = sativ.UnitFrames.focus.ref
		DB.UnitFrames.focus.scale = sativ.UnitFrames.focus.scale
		
		DB.UnitFrames.party.x = sativ.UnitFrames.party.x
		DB.UnitFrames.party.y = sativ.UnitFrames.party.y
		DB.UnitFrames.party.ref = sativ.UnitFrames.party.ref
		DB.UnitFrames.party.scale = sativ.UnitFrames.party.scale
		
		DB.UnitFrames.arena.x = sativ.UnitFrames.arena.x
		DB.UnitFrames.arena.y = sativ.UnitFrames.arena.y
		DB.UnitFrames.arena.ref = sativ.UnitFrames.arena.ref
		DB.UnitFrames.arena.scale = sativ.UnitFrames.arena.scale
		
		DB.UnitFrames.showClass = sativ.UnitFrames.showClass
		
		DB.ActionBars.modify = sativ.ActionBars.modify
		DB.ActionBars.macroText = sativ.ActionBars.macroText
		DB.ActionBars.CastBar.x = sativ.ActionBars.CastBar.x
		DB.ActionBars.CastBar.y = sativ.ActionBars.CastBar.y
		
		ReloadUI()
	end)	
	frame:AddChild(sativButton)
	
			-- PLAYERFRAME
	local playerLabel = AceGUI:Create("Label")
	playerLabel:SetText("  Player Frame: ")
	playerLabel:SetWidth(90)
	frame:AddChild(playerLabel)
	local playerRef = AceGUI:Create("Dropdown")
	playerRef:SetLabel("      Anchor Point")
	playerRef:SetList(refPoints)
	playerRef:SetText(self.db.profile.UnitFrames.player.ref)
	playerRef:SetWidth(130)
	playerRef:SetCallback("OnValueChanged", playerDropdown)
	frame:AddChild(playerRef)
	local playerX = AceGUI:Create("EditBox")
	playerX:SetLabel("      Horizontal Offset")
	playerX:SetWidth(130)
	playerX:SetText(self.db.profile.UnitFrames.player.x)
	playerX:SetCallback("OnEnterPressed", playerXChange)
	local playerY = AceGUI:Create("EditBox")
	playerY:SetLabel("      Vertical Offset")
	playerY:SetWidth(130)
	playerY:SetText(self.db.profile.UnitFrames.player.y)
	playerY:SetCallback("OnEnterPressed", playerYChange)
	frame:AddChild(playerX)
	frame:AddChild(playerY)
	local playerScl = AceGUI:Create("Slider")
	playerScl:SetLabel("Scale")
	playerScl:SetSliderValues(.5, 2, .1)
	playerScl:SetValue(self.db.profile.UnitFrames.player.scale)
	playerScl:SetWidth(130)
	playerScl:SetCallback("OnMouseUp", playerSclChange)
	frame:AddChild(playerScl)
	
			-- TARGETFRAME
	local targetLabel = AceGUI:Create("Label")
	targetLabel:SetText("  Target Frame: ")
	targetLabel:SetWidth(90)
	frame:AddChild(targetLabel)
	local targetRef = AceGUI:Create("Dropdown")
	targetRef:SetLabel(" ") -- Any empty SetLabel's are for spacing reasons
	targetRef:SetList(refPoints)
	targetRef:SetText(self.db.profile.UnitFrames.target.ref)
	targetRef:SetWidth(130)
	targetRef:SetCallback("OnValueChanged", targetDropdown)
	frame:AddChild(targetRef)
	local targetX = AceGUI:Create("EditBox")
	targetX:SetLabel(" ")
	targetX:SetWidth(130)
	targetX:SetText(self.db.profile.UnitFrames.target.x)
	targetX:SetCallback("OnEnterPressed", targetXChange)
	local targetY = AceGUI:Create("EditBox")
	targetY:SetLabel(" ")
	targetY:SetWidth(130)
	targetY:SetText(self.db.profile.UnitFrames.target.y)
	targetY:SetCallback("OnEnterPressed", targetYChange)
	frame:AddChild(targetX)
	frame:AddChild(targetY)
	local targetScl = AceGUI:Create("Slider")
	targetScl:SetLabel(" ")
	targetScl:SetSliderValues(.5, 2, .1)
	targetScl:SetValue(self.db.profile.UnitFrames.target.scale)
	targetScl:SetWidth(130)
	targetScl:SetCallback("OnMouseUp", targetSclChange)
	frame:AddChild(targetScl)
	
			-- FOCUSFRAME
	local focusLabel = AceGUI:Create("Label")
	focusLabel:SetText("  Focus Frame: ")
	focusLabel:SetWidth(90)
	frame:AddChild(focusLabel)
	local focusRef = AceGUI:Create("Dropdown")
	focusRef:SetLabel(" ")
	focusRef:SetList(refPoints)
	focusRef:SetText(self.db.profile.UnitFrames.focus.ref)
	focusRef:SetWidth(130)
	focusRef:SetCallback("OnValueChanged", focusDropdown)
	frame:AddChild(focusRef)
	local focusX = AceGUI:Create("EditBox")
	focusX:SetLabel(" ")
	focusX:SetWidth(130)
	focusX:SetText(self.db.profile.UnitFrames.focus.x)
	focusX:SetCallback("OnEnterPressed", focusXChange)
	local focusY = AceGUI:Create("EditBox")
	focusY:SetLabel(" ")
	focusY:SetWidth(130)
	focusY:SetText(self.db.profile.UnitFrames.focus.y)
	focusY:SetCallback("OnEnterPressed", focusYChange)
	frame:AddChild(focusX)
	frame:AddChild(focusY)
	local focusScl = AceGUI:Create("Slider")
	focusScl:SetLabel(" ")
	focusScl:SetSliderValues(.5, 2, .1)
	focusScl:SetValue(self.db.profile.UnitFrames.focus.scale)
	focusScl:SetWidth(130)
	focusScl:SetCallback("OnMouseUp", focusSclChange)
	frame:AddChild(focusScl)
	
			-- ARENAFRAME
	local arenaLabel = AceGUI:Create("Label")
	arenaLabel:SetText("  Arena Frames: ")
	arenaLabel:SetWidth(90)
	frame:AddChild(arenaLabel)
	local arenaRef = AceGUI:Create("Dropdown")
	arenaRef:SetLabel(" ")
	arenaRef:SetList(refPoints)
	arenaRef:SetText(self.db.profile.UnitFrames.arena.ref)
	arenaRef:SetWidth(130)
	arenaRef:SetCallback("OnValueChanged", arenaDropdown)
	frame:AddChild(arenaRef)
	local arenaX = AceGUI:Create("EditBox")
	arenaX:SetLabel(" ")
	arenaX:SetWidth(130)
	arenaX:SetText(self.db.profile.UnitFrames.arena.x)
	arenaX:SetCallback("OnEnterPressed", arenaXChange)
	local arenaY = AceGUI:Create("EditBox")
	arenaY:SetLabel(" ")
	arenaY:SetWidth(130)
	arenaY:SetText(self.db.profile.UnitFrames.arena.y)
	arenaY:SetCallback("OnEnterPressed", arenaYChange)
	frame:AddChild(arenaX)
	frame:AddChild(arenaY)
	local arenaScl = AceGUI:Create("Slider")
	arenaScl:SetLabel(" ")
	arenaScl:SetSliderValues(.5, 2, .1)
	arenaScl:SetValue(self.db.profile.UnitFrames.arena.scale)
	arenaScl:SetWidth(130)
	arenaScl:SetCallback("OnMouseUp", arenaSclChange)
	frame:AddChild(arenaScl)
	
			-- PARTYFRAME
	local partyLabel = AceGUI:Create("Label")
	partyLabel:SetText("  Party Frames: ")
	partyLabel:SetWidth(90)
	frame:AddChild(partyLabel)
	local partyRef = AceGUI:Create("Dropdown")
	partyRef:SetLabel(" ")
	partyRef:SetList(refPoints)
	partyRef:SetText(self.db.profile.UnitFrames.party.ref)
	partyRef:SetWidth(130)
	partyRef:SetCallback("OnValueChanged", partyDropdown)
	frame:AddChild(partyRef)
	local partyX = AceGUI:Create("EditBox")
	partyX:SetLabel(" ")
	partyX:SetWidth(130)
	partyX:SetText(self.db.profile.UnitFrames.party.x)
	partyX:SetCallback("OnEnterPressed", partyXChange)
	local partyY = AceGUI:Create("EditBox")
	partyY:SetLabel(" ")
	partyY:SetWidth(130)
	partyY:SetText(self.db.profile.UnitFrames.party.y)
	partyY:SetCallback("OnEnterPressed", partyYChange)
	frame:AddChild(partyX)
	frame:AddChild(partyY)
	local partyScl = AceGUI:Create("Slider")
	partyScl:SetLabel(" ")
	partyScl:SetSliderValues(.5, 2, .1)
	partyScl:SetValue(self.db.profile.UnitFrames.party.scale)
	partyScl:SetWidth(130)
	partyScl:SetCallback("OnMouseUp", partySclChange)
	frame:AddChild(partyScl)
	
			-- EXTRAS	------------------------------------
	local toggleClassIcons = AceGUI:Create("CheckBox")
	if self.db.profile.UnitFrames.classIcons then
		toggleClassIcons:SetValue(true)
	end
	toggleClassIcons:SetLabel("Class Icons")
	toggleClassIcons:SetDescription("Enable // Disable class icons on Target and Focus frames.")
	toggleClassIcons:SetCallback("OnValueChanged", function(widget, event, newVal)
		PUI.db.profile.UnitFrames.classIcons = newVal
		reloadNeeded = true
	end)
	frame:AddChild(toggleClassIcons)
	--------------------------------------------------------
	local toggleActionBars = AceGUI:Create("CheckBox")
	toggleActionBars:SetLabel("Modify Action Bars")
	if self.db.profile.ActionBars.modify then
		toggleActionBars:SetValue(true)
	end
	toggleActionBars:SetDescription("Enable // Disable the modification & replacement of Action Bars (disable if using Bartender or similar)")
	frame:AddChild(toggleActionBars)
	--------------------------------------------------------
	local toggleMacro = AceGUI:Create("CheckBox")
	local isDisabled = false
		local function onABUpdate(widget, event, newVal) -- Applies to toggleActionBars; requires toggleMacro to be created first.
			if toggleActionBars:GetValue() == false then
				toggleMacro:SetDisabled(true)
				isDisabled = true
			else
				toggleMacro:SetDisabled(false)
				isDisabled = false
			end
			PUI.db.profile.ActionBars.modify = newVal
			reloadNeeded = true
		end
		toggleActionBars:SetCallback("OnValueChanged", onABUpdate)
	if toggleActionBars:GetValue() == false then
		toggleMacro:SetDisabled(true)
		isDisabled = true
	else
		toggleMacro:SetDisabled(false)
		isDisabled = false
	end
	toggleMacro:SetLabel("Show Macro Text")
	if self.db.profile.ActionBars.macroText then
		toggleMacro:SetValue(true)
	end
	toggleMacro:SetDescription("Enable // Disable macro text on hotkeys. Requires Action Bar modification to be enabled.")
	toggleMacro:SetCallback("OnValueChanged", function(widget, event, newVal)
		if isDisabled == false then
			PUI.db.profile.ActionBars.macroText = newVal
			reloadNeeded = true
		end
	end)
	frame:AddChild(toggleMacro)
end